<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link href="../style/steps.css" rel="stylesheet">
    <link href='https://fonts.googleapis.com/css?family=Roboto' rel='stylesheet'>
    <title>Analiza testów</title>
</head>
<body>
<div class="rule-container">
    <div class="row">
        <div class="rule-number">3</div>
        <div class="rule-header">Analiza testów</div>
    </div>
    <div class="rule-text-animation-container">
        <div class="rule-text">Celem grupy czynności w analizie testów jest przeanalizowanie podstawy testów w celu
            zidentyfikowania testowalnych cech i zdefiniowania związanych z nimi warunków testowych. Innymi słowy,
            analiza testów służy do ustalenia tego, „co” należy przetestować (w kategoriach mierzalnych kryteriów
            pokrycia).
            <p>Główne czynności wykonywane w ramach analizy testów to:</p>
            <ul>
                <li>dokonywanie analizy podstawy testów właściwej dla rozważanego poziomu testów, np.:
                    <p>a) specyfikacji wymagań, takich jak: wymagania biznesowe, wymagania funkcjonalne, wymagania
                        systemowe, historyjki użytkownika, opowieści (ang. epic), przypadki użycia lub podobne
                        produkty
                        pracy, które określają pożądane zachowanie funkcjonalne i niefunkcjonalne modułu lub
                        systemu;</p>
                    <p>
                        b) informacji dotyczących projektu i implementacji, takich jak: diagramy lub dokumenty
                        opisujące
                        architekturę systemu lub oprogramowania, specyfikacje projektowe, przepływy wywołań, modele
                        oprogramowania (np. diagramy UML lub diagramy związków encji), specyfikacje interfejsów lub
                        podobne produkty pracy, które określają strukturę modułu lub systemu;</p>
                    <p>
                        c) implementacji samego modułu lub systemu, w tym kodu, metadanych, zapytań do bazy danych
                        oraz
                        interfejsów;</p>
                    <p>
                        d) raportów z analizy ryzyka, które mogą dotyczyć aspektów funkcjonalnych, niefunkcjonalnych
                        i
                        strukturalnych modułu lub systemu;</p>
                </li>
                <li>dokonywanie oceny testowalności podstawy testów i elementów testowych, w celu zidentyfikowania
                    często występujących typów defektów, które mogą powodować problemy z testowalnością, takich jak:
                    <p>a) niejednoznaczności;</p>
                    <p>b) pominięcia;</p>
                    <p>c) niespójności;</p>
                    <p>d) nieścisłości;</p>
                    <p>e) sprzeczności;</p>
                    <p>f) nadmiarowe (zbędne) instrukcje;</p>
                </li>
                <li>identyfikowanie cech i zbiorów cech, które mają zostać przetestowane;</li>
                <li>definiowanie warunków testowych w odniesieniu do poszczególnych cech oraz określenie ich
                    priorytetów
                    na podstawie analizy podstawy testów — z uwzględnieniem parametrów funkcjonalnych,
                    niefunkcjonalnych
                    i strukturalnych, innych czynników biznesowych i technicznych oraz poziomów ryzyka;
                </li>
                <li>stworzenie możliwości dwukierunkowego śledzenia powiązań między elementami podstawy testów a
                    związanymi z nimi warunkami testowymi.
                </li>
            </ul>
            <p>Zastosowanie technik czarnoskrzynkowych, białoskrzynkowych oraz technik opartych na doświadczeniu w
                ramach analizy testów (patrz rozdział 4.), pomaga zmniejszyć prawdopodobieństwo pominięcia ważnych
                warunków testowych oraz zdefiniować bardziej precyzyjne i dokładne warunki testowe.</p>
            <p>W niektórych przypadkach w wyniku analizy testów, definiowane są warunki testowe, które mają być
                wykorzystywane jako cele testów w kartach opisów testów. Karty opisu testów są typowymi produktami
                pracy
                w niektórych odmianach testowania opartego na doświadczeniu.</p>
            <p>Jeśli istnieje śledzenie powiązań między wspomnianymi powyżej celami testów a podstawą testów,
                możliwy
                jest pomiar pokrycia uzyskanego w trakcie testowania opartego na doświadczeniu.</p>
            <p>Identyfikowanie defektów na etapie analizy testów jest istotną potencjalną korzyścią, zwłaszcza gdy
                nie
                stosuje się żadnego innego procesu przeglądu i/lub gdy proces testowy jest ściśle powiązany z
                procesem
                przeglądu. Czynności wykonywane w ramach analizy testów pozwalają zweryfikować, czy wymagania są
                spójne,
                prawidłowo wyrażone i kompletne, a także sprawdzić, czy właściwie odzwierciedlają one potrzeby
                klienta,
                użytkowników i innych interesariuszy. Warto w tym miejscu podać przykład takich technik jak:
                wytwarzanie
                sterowane zachowaniem (ang. Behavior Driven Development — BDD) i wytwarzanie sterowane testami
                akceptacyjnymi (ang. Acceptance Test Driven Development — ATDD), które obejmują generowanie warunków
                testowych i przypadków testowych na podstawie historyjek użytkownika i kryteriów akceptacji przed
                rozpoczęciem tworzenia kodu.</p>
            <p>Przewidują one również weryfikację i walidację historyjek użytkownika i kryteriów akceptacji oraz
                wykrywanie występujących w nich defektów.</p>
        </div>
    </div>
</div>
</body>
</html>
